import { Router, Request, Response } from "express";
import * as bodyparser from "body-parser";

import { authRoute } from "../security/token";

const levelRouter = Router();
levelRouter.use(bodyparser.json());
levelRouter.use(authRoute);

levelRouter.get("/:id/vocab", async (req: Request, res: Response) => {
    // TODO: Implement
    console.log("Stub(get): /level/:id/vocab");

    if (!req.params) {
        res.send({
            error: "400",
            data: {
                msg: "No level specified",
            },
        });
        return;
    }

    res.send({
        error: "0",
        data: {
            vocab: [{
                german: ["Wein"],
                hint: "Worte auf '-um' sind meistens NeutrUM",
                type: 0,
                latin: {
                    grundform: "Vinum",
                    genitiv: "Vini",
                    genus: "Neutrum"
                },
                id: 0
            }],
        }
    });
});

export default levelRouter;
