import { connect } from "react-redux";

import {
    setNextLevel, setDashboardNLLoading, setTopTen, setDashboardTTLoading,
    setDashboardLRLoading, setLastReview,
} from "../actions";

import { ILevel } from "../models/level";
import { ILearner } from "../models/learner";
import { IReviewMetadata } from "../models/review";

import DashboardPage from "../pages/dashboard";

const mapStateToProps = state => {
    return {
        nextLevel: state.nextLevel,
        loadingNextLevel: state.dashboard.loadingNL,
        loadingTopTen: state.dashboard.loadingTT,
        topTen: state.topTen,
        loadingLastReview: state.dashboard.loadingLR,
        lastReview: state.lastReview,
    };
};
const mapDispatchToProps = dispatch => {
    return {
        setLoadingNL: (state: boolean) => dispatch(setDashboardNLLoading(state)),
        setNextLevel: (level: ILevel) => dispatch(setNextLevel(level)),
        setTopTen: (topTen: ILearner[]) => dispatch(setTopTen(topTen)),
        setLoadingTT: (state: boolean) => dispatch(setDashboardTTLoading(state)),
        setLastReview: (review: IReviewMetadata) => dispatch(setLastReview(review)),
        setLoadingLR: (state: boolean) => dispatch(setDashboardLRLoading(state)),
    }
};

const DashboardContainer = connect(mapStateToProps,
    mapDispatchToProps)(DashboardPage);
export default DashboardContainer;
